package de.almostintelligent.jaste.loader;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;

public class FileTemplateLoader implements TemplateLoader {

	private String prefix;
	
	private String suffix;
	
	public FileTemplateLoader(String prefix, String suffix) {
		this.prefix=prefix;
		this.suffix=suffix;
	}
	
	@Override
	public Reader getReader(String name) throws IOException {
		File f = new File(prefix + name + suffix);
		if(!f.exists()) {
			throw new IOException("File does not exist: "+f.getPath());
		}
		return new FileReader(f);
	}

}
